-- mvh 20151206: fix 1.4.17d compatibility
-- 20160709   mvh   fix for PatientID with spaces in it

webscriptaddress = webscriptaddress or webscriptadress or 'dgate.exe'
local ex = string.match(webscriptaddress, 'dgate(.*)')
local query_pid = '';
local query_pna = '';
local query_pst = '';
local query_sta = '';
 
function mycomp(a,b)
    if a.PatientName == nil and b.PatientName == nil then
      return false
    end
    if a.PatientName == nil then
      return true
    end
    if b.PatientName == nil then
      return false
    end
    return a.PatientName < b.PatientName
  end

function InitializeVar()
 if (CGI('patientidmatch') ~='') then
     query_pid='*'..CGI('patientidmatch')..'*'
 else
  query_pid='' 
 end

 if (patientnamematch ~= '') then
     query_pna='*'..CGI('patientnamematch')..'*' ;
 else 
  query_pna='' 
 end

 if (CGI('studydatematch') ~= '') then
     query_pst='*'..CGI('studydatematch')..'*' ;
 else
   query_pst='' 
 end

 if (CGI('startdatematch') ~= '') then
     query_sta='*'..CGI('startdatematch')..'*' ;
 else 
  query_sta='' 
 end
end;
 

function mcoalesce(fff)
  if fff =='' or fff == nil then
    return '';
  end; 
 local res =fff;
 return res
end;

function querypats()
  local patis, b, s;

  InitializeVar()
  s = servercommand('get_param:MyACRNema')
  b=newdicomobject();
  b.QueryRetrieveLevel='PATIENT'
  b.PatientID        = query_pid;
  b.PatientName      = query_pna;
  b.PatientSex = '';
  b.PatientBirthDate = '';
  patis=dicomquery(s, 'PATIENT', b);
  
  patist={}
  for k1=0,#patis-1 do
    patist[k1+1]={}
    patist[k1+1].PatientID          = patis[k1].PatientID
    patist[k1+1].PatientName        = patis[k1].PatientName
    patist[k1+1].PatientSex         = patis[k1].PatientSex
    patist[k1+1].PatientBirthDate   = patis[k1].PatientBirthDate
  end
  return patist
end;


HTML("Content-type: text/html\nCache-Control: no-cache\n");

print(
[[
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Conquest DICOM server - version]]..version..[[</title>]]..
[[<style type="text/css">
body { font:10pt Verdana; }
a { color:blue; }
#content { background-color:#dddddd; width:200px; margin-top:2px; }
</style>
]]
)

print(
[[
<!-- Javascript goes in the document HEAD -->
<script type="text/javascript">
function altRows(id){
	if(document.getElementsByTagName){  
		
		var table = document.getElementById(id);  
		var rows = table.getElementsByTagName("tr"); 
		 
		for(i = 0; i < rows.length; i++){          
			if(i % 2 == 0){
				rows[i].className = "evenrowcolor";
			}else{
				rows[i].className = "oddrowcolor";
			}      
		}
	}
}
window.onload=function(){
	altRows('alternatecolor');
}
</script>

<!-- CSS goes in the document HEAD or added to your external stylesheet -->
<style type="text/css">
table.altrowstable {
	font-family: verdana,arial,sans-serif;
	font-size:16px;
	color:#333333;
	border-width: 1px;
	border-color: #a9c6c9;
	border-collapse: collapse;
}
table.altrowstable th {
	border-width: 1px;
	padding: 8px;
	border-style: solid;
	border-color: #a9c6c9;
}
table.altrowstable td {
	border-width: 1px;
	padding: 8px;
	border-style: solid;
	border-color: #a9c6c9;
}
.oddrowcolor{
	background-color:#d4e3e5;
}
.evenrowcolor{
	background-color:#c3dde0;
}
table.altrowstable tr:first-child {
	font-weight:bold;
}

table.altrowstable Caption {
    font-weight:bold;
    color: yellow;
    background: green;
}

</style>
</head> 
<body BGCOLOR='CFDFCF'>
]]
)

HTML("<H1>Welcome to Conquest DICOM server - version %s</H1>", version)

local pats=querypats() 
if query_pna ~= '' then
  table.sort(pats, mycomp)
end

print("<table class='altrowstable' id='alternatecolor' RULES=ALL BORDER=1>");

if (query ~= '') then  
	HTML("<Caption>List of selected patients (%s) on local server</caption>", #pats)
else   
	HTML("<Caption>List of all patients (%s) on local server</caption>", #pats)
end

print("<TR><TD>Patient ID<TD>Name<TD>Sex<TD>Birth Date</TR>"); 

for i=1,#pats do
  t = string.format("<A HREF=dgate%s?%s&mode=liststudies&key=%s&query=patientid+=+'%s' title='Click to see studies'>%s</A>", ex, extra, tostring(key or ''),string.gsub(pats[i].PatientID, ' ', '+'),mcoalesce(pats[i].PatientID));
  s = string.format("<TR><TD>%s<TD>%s<TD>%s<TD>%s</TR>",t,mcoalesce(pats[i].PatientName),mcoalesce(pats[i].PatientSex),mcoalesce(pats[i].PatientBirthDate));
  print(s)
end 

print
[[
</table>
</body>
</html>
]]
